//=========================================================================
// Java Adapter Design Pattern - Testprogramm
//=========================================================================
import java.io.BufferedReader;
import java.io.InputStreamReader;

public class Adapter
{
   //-------------------------------------------------------------------------
   // Hauptprogramm
   //-------------------------------------------------------------------------
   public static void main(String[] args)
   {
      double            fEingabe   = 0.0;
      double            fAusgabe   = 0.0;
      int               nAuswahl   = 0;
      InputStreamReader rStream    = new InputStreamReader(System.in);
      BufferedReader    rInput     = new BufferedReader(rStream);
      ADIUmrechner      rUmrechner = null;
      char              cEnde;

      try
      {
         System.out.println("Bitte Umrechnungsart eingeben: ");
         System.out.println("1 = Inch     in cm");
         System.out.println("2 = Gallonen in Liter");

         nAuswahl = Integer.parseInt(rInput.readLine());
         switch (nAuswahl)
         {
            case 1 : rUmrechner = new ADInchToCM();      break;
            case 2 : rUmrechner = new ADGallonToLiter(); break;
         }

         if (rUmrechner != null)
         {
            System.out.println("Bitte umzurechnenden Wert eingeben");
            fEingabe = Double.parseDouble(rInput.readLine());
            fAusgabe = rUmrechner.berechne (fEingabe);
            System.out.println("Der umgerechnete Wert betrgt " + fAusgabe);
         }
      }
      catch (Exception e)
      {
         e.printStackTrace();
      }
   }
}
