//=========================================================================
/** Java Bridge Design Pattern - einzelne Ware, Sicht des Verkaufsleiters
 *  Created on 15.11.2003
 */
//=========================================================================
import java.text.DecimalFormat;

public class BRVerkaufsleiterListeItem extends BRVerkaeuferListeItem
{
   private int    nWarenGruppe  = 0;
   private double fMinimumpreis = 0.0;
   
   //---------------------------------------------------------------------------
   /**
    * Constructor
    */
   //---------------------------------------------------------------------------
   public BRVerkaufsleiterListeItem(BRModelItem pItem)
   {
      super(pItem);
      nWarenGruppe = pItem.nWarengruppe;
      switch (nWarenGruppe)
      {
         case 0:  fMinimumpreis = pItem.fEinkaufspreis + pItem.fEinkaufspreis * 1.2;
                  fMinimumpreis = fMinimumpreis * 1.16;  
                  break;
         case 1:  fMinimumpreis = pItem.fEinkaufspreis + pItem.fEinkaufspreis * 1.0;
                  fMinimumpreis = fMinimumpreis * 1.16;  
                  break;
         default: fMinimumpreis = pItem.fEinkaufspreis + pItem.fEinkaufspreis * 0.5;
                  fMinimumpreis = fMinimumpreis * 1.16;  
                  break;
      }
   }

   //---------------------------------------------------------------------------
   /**
    * toString
    */
   //---------------------------------------------------------------------------
   public String toString()
   {
      DecimalFormat df = new DecimalFormat("###,###,##0.00");
      StringBuffer  sb = new StringBuffer(80);
      
      sb.append(super.toString());
      sb.append("   Warengruppe: ");
      sb.append(nWarenGruppe);
      sb.append("   Mindestpreis: ");
      sb.append(df.format(fMinimumpreis));
      sb.append(" ");
      
      return sb.toString();
   }
}
