//=========================================================================
/** Java Command Design Pattern - Kreis
 */
//=========================================================================
import java.awt.Color;

public class CMKreis implements ICMCommandListener
{
   private int   xKoordinate = 0;
   private int   yKoordinate = 0; 
   private int   nRadius     = 0;
   private Color rFillColor  = null; 
   private Color rLineColor  = Color.black; 
   
   //----------------------------------------------------------------------
   public CMKreis(int px, int py, int pRad)
   {
      super();
      xKoordinate = px;
      yKoordinate = py; 
      nRadius     = pRad;
   }

   //----------------------------------------------------------------------
   public void doCommand (CMCommand pCommand)
   {
      if (pCommand.getCommandText().equals("Fillcolor"))
      {
         rFillColor = (Color)(pCommand.getData());
      }
      else if (pCommand.getCommandText().equals("Linecolor"))
      {
         rLineColor = (Color)(pCommand.getData());
      }
      else if (pCommand.getCommandText().equals("Resize"))
      {
         nRadius = (int)(nRadius * ((Double)(pCommand.getData())).doubleValue());
      }
   }

   //----------------------------------------------------------------------
   public String toString()
   {
      StringBuffer sb = new StringBuffer();
      sb.append ("Kreis: " + xKoordinate + ", " + yKoordinate + ", rad " 
                 + nRadius + ", Line: " + rLineColor + ", Fill: " + rFillColor);
      return sb.toString();
   }
}
