//=========================================================================
/** Java Flyweight Design Pattern - selbstndig nachladende Klasse
 */
//=========================================================================
import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

public class FLFilereaderFlyweight
{
   private String sFilename = null;
   private String sText     = null;
   
   //----------------------------------------------------------------------
   public FLFilereaderFlyweight(String pFilename)
   {
      super();
      setFilename(pFilename);
   }
   
   //----------------------------------------------------------------------
   public String getFilename()
   {
      return sFilename;
   }

   //----------------------------------------------------------------------
   public void setFilename(String pFilename)
   {
      if (!sFilename.equals(pFilename))
      {
         sFilename = pFilename;
         sText = null;
      }
   }

   //----------------------------------------------------------------------
   public String getText()
   {
      if (sText == null)
      {
         System.out.println("*** Text not in Memory - now Loading: " + sFilename);
         try
         {
            StringBuffer   sBuffer = new StringBuffer(4096);
            String         sLine   = null;
            FileReader     rFileIn = new FileReader(sFilename);
            BufferedReader rIn     = new BufferedReader(rFileIn);
            
            while ((sLine = rIn.readLine()) != null)
            {
               sBuffer.append(sLine);
               sBuffer.append("\n");
            }
            rIn.close();
            sText = sBuffer.toString();
         }
         catch (FileNotFoundException e)
         {
            System.out.println(e);         
         }
         catch (IOException e)
         {
            System.out.println(e);         
         }
      }
      else
      {
         System.out.println("*** Text in Memory - no Loading needed: " + sFilename);
      }
      return sText;
   }
   
   public String toString()
   {
      if (sText == null) 
      {
         return (sFilename + " not read yet");
      }
      return (sFilename + "Lenght: " + sText.length());
   }
}
