//=========================================================================
/** Java Proxy Design Pattern - Administratorproxy
 */
//=========================================================================
public class PXAdministratorProxy implements IPXDatalistProxy
{
   private PXDatalist rList = null;

   //----------------------------------------------------------------------
   public PXAdministratorProxy(PXDatalist pList)
   {
      super();
      rList = pList;
   }

   //----------------------------------------------------------------------
   public void anlegen (String pVorname, String pNachname, int pKdNr)
   {
      rList.add(new PXDatalistItem(pVorname, pNachname, pKdNr));
   }
   
   //----------------------------------------------------------------------
   public void aendern (int pIdx, String pVorname, String pNachname, int pKdNr)
   {
      PXDatalistItem rItem = rList.get(pIdx); 
      if (rItem != null)
      {
         rItem.setVorname(pVorname);
         rItem.setNachname(pNachname);
         rItem.setKundenNr(pKdNr);
      }
   }
   
   //----------------------------------------------------------------------
   public void loeschen (int pIdx)
   {
      rList.remove(pIdx); 
   }
   
   //----------------------------------------------------------------------
   public void anzeigen (int pIdx)
   {
      PXDatalistItem rItem = rList.get(pIdx); 
      if (rItem != null)
      {
         System.out.println(rItem.getNachname() + ", " + rItem.getVorname() 
                            + " (" + rItem.getKundenNr() + ")");
      }
   }
   
   //----------------------------------------------------------------------
   public void anzeigen ()
   {
      for (int i=0; i<rList.size(); i++)
      {
         anzeigen(i);
      }
   }
}
