//=========================================================================
/** Java Singleton Design Pattern - Singleton Systemkonstanten
 */
//=========================================================================
public final class SISystemkonstanten
{
   private static SISystemkonstanten rSingleton  = null;
   private        double             fMWSTFaktor = 0.0;

   //----------------------------------------------------------------------
   // Constructor
   //----------------------------------------------------------------------
   private SISystemkonstanten ()
   {
      // Auslesen der Konstanten aus einer Datenbank oder Konfigurationsdatei
      fMWSTFaktor = 0.17;
   }

   //----------------------------------------------------------------------
   // Singleton holen
   //----------------------------------------------------------------------
   static public SISystemkonstanten get ()
   {
      if (rSingleton == null)
      {
         rSingleton = new SISystemkonstanten();
      }
      return rSingleton;
   }

   //----------------------------------------------------------------------
   // Singleton lschen (bleibt sonst erhalten bis Virtuelle Maschine 
   // beendet wird
   //----------------------------------------------------------------------
   static public void remove ()
   {
      if (rSingleton != null)
      {
         rSingleton = null;
      }
   }

   //----------------------------------------------------------------------
   // Zugriff auf Wert im Singleton
   //----------------------------------------------------------------------
   public double getMWSTFaktor ()
   {
      return rSingleton.fMWSTFaktor;
   }
}
