//=========================================================================
/** Java Singleton Design Pattern - Text, zu speicherndes Objekt
 */
//=========================================================================
public class STLongText
{
   private String         sText         = null;
   private STSaveStrategy rSaveStrategy = null;
   
   //----------------------------------------------------------------------
   public STLongText()
   {
      super();
   }

   //----------------------------------------------------------------------
   public String getText()
   {
      return sText;
   }

   //----------------------------------------------------------------------
   public void setText(String pString)
   {
      sText = pString;
   }
   
   //----------------------------------------------------------------------
   public STSaveStrategy getSaveStrategy()
   {
      return rSaveStrategy;
   }

   //----------------------------------------------------------------------
   public void setSaveStrategy(STSaveStrategy pStrategy)
   {
      rSaveStrategy = pStrategy;
   }

   //----------------------------------------------------------------------
   public void save()
   {
      if (rSaveStrategy == null)
      {
         System.out.println ("Cannot save, no Save-Strategy chosen");
      }
      else
      {
         rSaveStrategy.save(sText);
      }
   }
}
