//=========================================================================
/** Java Template Method Design Pattern - 
 *  TMFilesaver, abstrakte Basisklasse
 *  Created on 18.04.2003
 */
//=========================================================================
import java.io.FileWriter;

public abstract class TMFilesaver
{
	//-------------------------------------------------------------------------
	// Constructor
	//-------------------------------------------------------------------------
	public TMFilesaver ()
	{
	}

	//-------------------------------------------------------------------------
	// Template Method save
	//-------------------------------------------------------------------------
	public FileWriter save (FileWriter rDatei, String sFilename)
	{
		rDatei = save_open (rDatei, sFilename);
		if (rDatei != null)
		{
			save_write (rDatei); // abstract !
			rDatei = save_close (rDatei);
		}
		return rDatei;
	}

	//-------------------------------------------------------------------------
	// save_open Standardmethode. Kann bei Bedarf gendert werden
	//-------------------------------------------------------------------------
	protected FileWriter save_open (FileWriter rDatei, String sFilename)
	{
		StringBuffer sFullname = new StringBuffer (sFilename);
		sFullname.append(".sav");
		try
		{
			rDatei = new FileWriter (sFullname.toString());
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
		return rDatei;
	}

	//-------------------------------------------------------------------------
	// save_write muss in nicht-abstrakter Klasse berschrieben werden
	//-------------------------------------------------------------------------
	protected abstract void save_write (FileWriter rDatei);
	
	//-------------------------------------------------------------------------
	// save_close Standardmethode. Kann bei Bedarf gendert werden
	//-------------------------------------------------------------------------
	protected FileWriter save_close (FileWriter rDatei)
	{
		try
		{
		   if (rDatei != null) rDatei.close();
		   rDatei = null;
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
		return rDatei;
	}
}
